﻿Type=Activity
Version=2.02
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'*******************************************************
'*
' Sample for Vitamiob4a (b4a-wrapper of Vitamio-plugin)
'
' VitamioB4A is a B4A-Wrapper of the Vitamio-plugin. The plugin is an Android APK which 
' includes a collection of media demuxers, decoders, filters besides some video and audio 
' output libraries. If the user does not have the plugin installed, the user will be prompted 
' to download and install it from Google Play. Since the first release of the B4A-wrapper, many
' other features have been added and now only subtitles-features of the VideoView-class are missing.
'
' Sample requires vitamiob4a-library and vitamio-library
' android:minSdkVersion="8" (not tested)
' author: moster67
' date: July 8, 2012
' version 1.01 
' Successive releases:
' version 1.05 - July 14, 2012
'
'*
'*******************************************************

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	 Dim vv As VideoView 'make sure to add vitamiob4a-library and vitamio-library to your extra-library folder
	 Dim myPanel As Panel
	 Dim InitialLayoutSet As Boolean
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Main.MyPhone.SetScreenOrientation(0)
	myPanel.Initialize("myPanel")
	Activity.AddView(myPanel,0,0,100%x,100%y) 'adding a panel so I can use events by clicking/long-clicking the panel. Useful for implementing OSD (onScreenDisplay).
	vv.Initialize("vv")
	myPanel.AddView(vv, 10dip, 10dip, 100%x,100%y)
	
	LoadAndPlayMedia
	

End Sub

Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub
Sub LoadAndPlayMedia

	'For testing, it is better to try with a local video-file than the streams I have furnished since they are not always online.
	
	'Example of loading a stream (might be slow in loading due to video-quality such as HD, internet-speed, band-width etc): 
	'vv.LoadVideo("http","http://devimages.apple.com/iphone/samples/bipbop/gear1/prog_index.m3u8") 'this is something from Apple
    'vv.LoadVideo("http","http://rtvgrand.com:8050") 'this is HD - might be extra slow but it looks nice once streaming starts.) http://rtvgrand.com:8050
	vv.LoadVideo("http",Main.VideoToStream)
	'Note: stream-URLs found by googling. Only for demostrating purposes. Don't distribute links.
	
	'Example of loading a local file:
	'vv.LoadVideo(File.DirRootExternal, "somefile.mp4") 'for streaming local files
	
	vv.MediaControllerEnabled=True 'Shows a media controller when the user touches the view. Default is false.  
	
'	vv.Left=(100%x - vv.Width) / 2
'	vv.Top=(100%y - vv.Height) / 2
'	vv.VideoLayout(0,0)
	ToastMessageShow("Long-click the videoview-screen to toggle between different layouts." ,False)
	
End Sub

Sub myPanel_LongClick
	ChangeVideo
End Sub
Sub ChangeVideo

	'example to toggle various layout-modes
	'it is not perfect. If someone want to improve, please do and post example. Thanks!
	
	Dim xx,yy,pos As Long
	Dim wi,he As Int
	
	'Log(vv.CurrentLayout)
	
	Dim LayoutToAssign As Int
	If vv.CurrentLayout=3 Then
		LayoutToAssign=0
	Else
		LayoutToAssign=vv.CurrentLayout + 1
	End If

	wi=vv.VideoWidth * 1dip
	he=vv.VideoHeight * 1dip
	
		vv.SetLayout(0,0,wi,he)
		vv.Invalidate 'needed?
		vv.VideoLayout(LayoutToAssign,0)
	
		'try to center videoview, especially in portrait-mode
		If LayoutToAssign = 0 Then
			vv.Left=(100%x - vv.Width) / 2
			vv.Top=(100%y - vv.Height) / 2
		Else If LayoutToAssign = 1 Then
			If GetDeviceLayoutValues.Width < GetDeviceLayoutValues.Height Then 'portrait
				vv.Top=(100%y - vv.Height) / 2
			End If
		End If
		
	'show layout selected
	Dim TypeOfLayout As String
	Select Case vv.CurrentLayout
		Case 0
		TypeOfLayout="Original Layout"
		Case 1
		TypeOfLayout="Scaling"
		Case 2
		TypeOfLayout="Stretching"
		Case 3
		TypeOfLayout="Zooming"
	End Select
		
	ToastMessageShow(xx & " - " & yy & " - " & TypeOfLayout,False)
      

End Sub
Sub vv_Complete
		 ToastMessageShow("Playing completed",False)
End Sub
Sub vv_error(what As Int,extra As Int)
'		From SDK:
'		Called to indicate an error.
'		Parameters:
'		what - the type of error that has occurred:
'		Constant: 1 -> MEDIA_ERROR_UNKNOWN
'		Constant: 200 -> MEDIA_ERROR_NOT_VALID_FOR_PROGRESSIVE_PLAYBACK
'		extra - an extra code, specific To the error. Typically implementation dependant.
'		Returns:
'		True If the method handled the error, False if it didn't. Returning false, or not having an OnErrorListener at all, will cause the OnCompletionListener to be called.
'		NOTE: VitamioB4A sets default Return value To True To disable vitamio's pop-up error messages: You can handle error messages using this error-event.		 
		 
'		Log("errorlog " & what & " - " & extra)
		If what=1 Then
			Dim t As String
			t=Main.VideoToStream
			t=t.Replace("flv","mp4")
			Main.VideoToStream=t
			Log("Corrected Video: " & Main.VideoToStream)
			LoadAndPlayMedia
			End If
End Sub
Sub vv_info(what As Int,extra As Int)
'		From SDK:
'		Called to indicate an info OR a warning.
'		Parameters:
'		what - the Type of info OR warning.
'		Constant: 700 -> MEDIA_INFO_VIDEO_TRACK_LAGGING
'		Constant: 701 -> MEDIA_INFO_BUFFERING_START
'		Constant: 702 -> MEDIA_INFO_BUFFERING_END
'		Constant: 801 -> MEDIA_INFO_NOT_SEEKABLE
'		extra - an extra code, specific to the info. Typically implementation dependant.
'		Returns:
'		True If the method handled the info, False if it didn't. Returning false, or not having an OnErrorListener at all, will cause the info to be discarded.
'		NOTE: VitamioB4A sets default return value to True

'		 Log("infolog " & what & " - " & extra)
		 
		 'example
		 If what = 700 Then 'if value is 700, reduce video-quality
			vv.VideoQuality(-16)
'			Log("Reduced video-quality")
		 End If
	 
End Sub
Sub vv_prepared
'		From SDK:
'		Called when the media File is ready For playback.
	
	Log("Media is ready for playback")
	 
	vv.VideoQuality(16) 'here we can set video-quality for instance (instead of using a timer like in previous sample-project)
	
	
	'here I am using this event to set video-layout
	If InitialLayoutSet=False Then
'		vv.VideoLayout(1,0)
		vv.VideoLayout(0,0)
		InitialLayoutSet=True
	End If
	
	'center the video
	vv.Left=(100%x - vv.Width) / 2
	vv.Top=(100%y - vv.Height) / 2
	
End Sub
Sub vv_buffering(percent As Int)

'		From SDK:
'		Called To update status in buffering a media stream.
'		Parameters:
'		percent - the percentage (0-100) of the buffer that has been filled thus far

'		Log("buffer-percent " & percent  & "%")
		If percent<90 Then
			Activity.Title="Streaming GF : buffer-percent " & percent  & "%"
		Else
			Activity.Title="Streaming GF"
		End If
End Sub

'Trap the back button
Sub Activity_KeyPress (KeyCode As Int) As Boolean                            
    If KeyCode = KeyCodes.KEYCODE_BACK Then
'		ToastMessageShow ("Please use Menu to exit.", True)
		Activity.Finish
		Return True  'Destroy event
	Else
		Return False
    End If 
End Sub